=== os/debian/changelog ===
openttd (0.3.4.1-1) unstable; urgency=low

  * Initial Release.

 -- Matthijs Kooijman <matthijs@katherina.student.utwente.nl>  Thu, 16 Sep 2004 00:59:38 +0200
